unit arifmetic;

interface
USES Dialogs,Math;

const
    MaxZ=4294967296; // 2^31 = 2147483647+1
    RazmerChisla = 64;
    NewDl= RazmerChisla + 1 ;
    NewDl_x2 = 2*NewDl + 1;
    KolBit= NewDl*32;   //   = 2048
    Dlina= (KolBit*100)div 332 ;

type
    VnTip = array[0..NewDl] of Cardinal;
    VnTip_x2 = array[0..(2*NewDl+1)] of Cardinal;


    //    String  VnTip   
procedure StrToMasP(s: string;var m: VnTip);
procedure MasToStrP(m: VnTip;var s: string);
{-----      -----}
procedure slog( a,b,c:VnTip;var r:VnTip);
procedure razn(a,b,c:VnTip;var r:VnTip);
procedure umn(a,b,c:VnTip;var r:VnTip);

  //    
procedure Stepen(a,n,c:VnTip;var r : VnTip);
procedure modul(var a:VnTip;b:VnTip);
procedure otn(a,b:VnTip;var c:VnTip;var ost:VnTip);

procedure SlogMod(a,b,c:VnTip;var r:VnTip);
procedure raznMod(a,b,c:VnTip;var r:VnTip);
procedure UmnMod(a,b,c:VnTip;var r:VnTip);

function A_MEN_B(a,b:VnTip):integer; //  
procedure Div2(var A:VnTip);      //   2

  //    
  //   ,   ..  
procedure slog2( a,b,c:VnTip;var r:VnTip);
procedure razn2(a,b,c:VnTip;var r:VnTip);
procedure umn2(a,b,c:VnTip;var r:VnTip_x2);
  //        
  //     ,      umn2

  //   Stepen2   modul2,
  //    ()  (.. )  
  //     1    . Stepen2
procedure modul2(var a:VnTip_x2;b:VnTip;KolSdv:Cardinal);
procedure Stepen2(a,n,c:VnTip;var r : VnTip);

function nlz(x:cardinal):cardinal;
   //         

procedure X2ToMas( a:VnTip_x2;var b:VnTip );
   //     VnTip_x2   VnTip


implementation

uses SysUtils;

{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}

procedure MasToX2(a:VnTip;var b:VnTip_x2 );
var i: integer;
begin
  for i:= 0 to NewDl do
     b[i]:=a[i];
  for i:= NewDl to NewDl_x2 do
     b[i]:=0;
end;

{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
procedure X2ToMas( a:VnTip_x2;var b:VnTip );
var i: integer;
begin
  for i:= 0 to NewDl do
     b[i]:=a[i];
  if b[0]>NewDl then b[0]:=NewDl;
end;

{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}

{====================================================}
procedure StrToMasP(s: string; var m: VnTip);
var i,k:integer;
    z,m1,perenos: Int64;
begin
  for i:=1 to NewDl do
     m[i]:=0;
  m[0]:=1;

  for i:= 1 to length(s) do
    begin
      perenos:= StrToInt(s[i]);
      for k:=1 to (m[0]) do
        begin
          m1:= m[k];
          z:= m1*10 +perenos;
          perenos:= z div MaxZ;
          m1:= z mod MaxZ;
          m[k]:=m1;
        end;
      if perenos>0 then
        begin
          inc(m[0]);
          m[m[0]]:=perenos;
        end;
    end;
end;

{====================================================}


procedure MasToStrP(m: VnTip;var s: string);
var i,j,k,baza: integer;
   f,fn: array[0..Dlina] of integer;
   perenos,z,z1,c,d:int64;
begin

    for i:= 0 to Dlina do
     begin                     //  FN ,NewFN
        F[i]:=0;
        FN[i]:=0;
     end;
    f[0]:=1;
    fn[0]:=1;
                        //  
                        //   . m

    k:=m[0];
                       // -  -  MaxZ
    Repeat

      for j:=0 to Dlina do
        fn[j]:= 0;
      fn[0]:=1;
                         // -     MaxZ
      baza:=0;
      Repeat
        inc(baza);
        d:=f[baza];
        perenos:= d*MaxZ;
        j:=baza;
        Repeat
          c:= fn[j];
          z:= c+ perenos;
          perenos:= z div 10;
          z1:= z mod 10;
          fn[j]:= z1;
          inc(j);
        Until (perenos=0);
        if fn[0]<j then fn[0]:=j-1;
      Until (baza=f[0]);

                        //   . - .
      perenos:= m[k];
      j:=0;
      while (perenos>0) do
        begin
          inc(j);
          c:= fn[j];
          z:= c+ perenos;
          perenos:= z div 10;
          z1:= z mod 10;
          fn[j]:=z1;
        end;
      if j>fn[0] then fn[0]:=j;

      for j:=0 to dlina do
        f[j]:= fn[j];

      dec(k);
    Until (k=0);


    S:='';
    if (f[0]=1)and(f[1]=0) then s:='0' //  ,   
      else
        for i:= f[0] downto 1 do
          S:=S + IntToStr(F[i]);

end;

{====================================================}

procedure slog(a,b,c:VnTip;var r:VnTip); assembler;
{  EAX -->    - a     }
{  EDX -->    - b     }
{  ECX -->    - c     }
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX

    mov ESI,eax  //   
    mov EBX,ecx
        CLD  // -  DI  SI  
{-------------------------------------------------}
    mov edi,r   //    r
    xor eax,eax
    mov ecx,dword ptr NewDl
  rep stosd            // r[1..NewDl]:=0

{-------------------------------------------------}
    lodsd            //  (razmer:=)eax:= a[0]
    cmp  EAX,[EDX]
    jae @Met1        // if a[0]<b[0] then
    mov EAX,[EDX]
@Met1:
    mov ECX,eax //razmer:= eax ,.. max  a[0]  b[0]
    mov edi,r    //  
    stosd     //     r 
    clc
{-------------------------------------------------}
@met_c:
    inc EDX        //    
    inc EDX
    inc EDX
    inc EDX
    LODSD
    ADC EAX,[EDX]  //         
    stosd
    loop @met_c
{-------------------------------------------------}

    JNC @net_rash   //    
    inc dword ptr r
    mov EAX,1
    stosd
@net_rash:
{-------------------------------------------------}

        POP     EBX
        POP     ESI
        POP     EDI    {   /    }
end;

{====================================================}

procedure razn(a,b,c:VnTip;var r:VnTip); assembler;
{  : a    b }
{  EAX -->    - a     }
{  EDX -->    - b     }
{  ECX -->    - c     }
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX

    mov ESI,eax  //   
    mov EBX,ecx
        CLD  // -  DI  SI  
{-------------------------------------------------}

    mov edi,r   //    r
    xor eax,eax
    mov ecx,dword ptr NewDl
    inc ecx
  rep stosd            // r[1..NewDl]:=0
{-------------------------------------------------}

    lodsd            //  (razmer:=)eax:= a[0]
    cmp  EAX,[EDX]
    jae @Met1        // if a[0]<b[0] then
    mov EAX,[EDX]
@Met1:
    mov ECX,eax //razmer:= eax ,.. max  a[0]  b[0]
    mov edi,r    //  
    stosd     //     r 
    clc
{-------------------------------------------------}

@met_c:
    inc EDX        //    
    inc EDX
    inc EDX
    inc EDX
    LODSD
    SBB EAX,[EDX]  //         
    stosd
    loop @met_c
{-------------------------------------------------}


     //    
    MOV EBX,r
@M_Umen_Razm_Raznosti:
    CMP DWORD PTR [EBX],1         //   =1,    
   JE @M_PROP_UMEN_Raznosti
    MOV EAX,DWORD PTR [EBX]
    CMP DWORD PTR [EBX+EAX*4],0
   JNE @M_PROP_UMEN_Raznosti
    DEC DWORD PTR [EBX]
   JMP @M_Umen_Razm_Raznosti
@M_PROP_UMEN_Raznosti:
{-------------------------------------------------}
        POP     EBX
        POP     ESI
        POP     EDI    {   /    }
end;

{====================================================}

{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}

{====================================================}

procedure umn2(a,b,c:VnTip;var r:VnTip_x2); assembler;
var pp:cardinal;
   AdrA,AdrB,AdrC:LongWord;
   RazmA,RazmB:LongWord;
{  EAX -->    - a     }
{  EDX -->    - b     }
{  ECX -->    - c     }
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX

    MOV AdrA,EAX //   
    MOV AdrB,EDX
    MOV AdrC,ECX
    MOV EAX,DWORD PTR [EAX]
    MOV RazmA,EAX
    MOV EAX,DWORD PTR [EDX]
    MOV RazmB,EAX
        CLD  // -  DI  SI  

{-------------------------------------------------}

    mov edi,r   //    r
    xor eax,eax
    mov ecx,dword ptr NewDl_x2
    inc ecx
  rep stosd            // r[1..NewDl]:=0
{-------------------------------------------------}
    MOV EAX,RazmA          //   
    ADD EAX,RazmB     //    r
    MOV EBX, R
    mov DWORD PTR [EBX], EAX //   r   .  
{
{-------------------------------------------------}
    MOV EBX,0

@M_Cikl_1:

    INC EBX
    MOV ECX,0
    MOV PP,0
    MOV EDI,EBX


@M_Cikl_2:   //    
    INC ECX
    MOV ESI,AdrA
    MOV EAX, DWORD PTR [ESI+ ECX*4]
    MOV ESI,AdrB
    MUL DWORD PTR [ESI+ EBX*4]

    ADD EAX,PP
    ADC EDX,0
    MOV PP,0

    MOV ESI,R
    ADD DWORD PTR [ESI+ EDI*4],EAX
    ADC PP,EDX

    INC EDI

    MOV EAX,AdrA
    CMP ECX, DWORD PTR [EAX]
   JB @M_Cikl_2

    MOV EAX,PP
    ADD DWORD PTR [ESI+ EDI*4],EAX

    MOV EAX,AdrB
    CMP EBX, DWORD PTR [EAX]
   JB @M_Cikl_1


{-------------------------------------------------}
    MOV ESI,R
    MOV ECX,DWORD PTR [ESI]       //  
@M_PROVERKA_RAZMERA:
    CMP DWORD PTR [ESI+ECX*4],0
   LOOPZ @M_PROVERKA_RAZMERA    //  =0
    INC ECX                       // .. ecx -    
    MOV DWORD PTR [ESI],ECX       //    
{-------------------------------------------------}

        POP     EBX
        POP     ESI
        POP     EDI    {   /    }
end;

{====================================================}


{====================================================}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{====================================================}

procedure umn(a,b,c:VnTip;var r:VnTip); assembler;
var pp:cardinal;
   AdrA,AdrB,AdrC:LongWord;
   RazmA,RazmB:LongWord;
{  EAX -->    - a     }
{  EDX -->    - b     }
{  ECX -->    - c     }
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX

    MOV AdrA,EAX //   
    MOV AdrB,EDX
    MOV AdrC,ECX
    MOV EAX,DWORD PTR [EAX]
    MOV RazmA,EAX
    MOV EAX,DWORD PTR [EDX]
    MOV RazmB,EAX
        CLD  // -  DI  SI  

{-------------------------------------------------}

    mov edi,r   //    r
    xor eax,eax
    mov ecx,dword ptr NewDl
    inc ecx
  rep stosd            // r[1..NewDl]:=0
{-------------------------------------------------}
    MOV EAX,RazmA          //   
    ADD EAX,RazmB     //    r
    MOV EBX, R
    mov DWORD PTR [EBX], EAX //   r   .  
{
{-------------------------------------------------}
    MOV EBX,0

@M_Cikl_1:

    INC EBX
    MOV ECX,0
    MOV PP,0
    MOV EDI,EBX


@M_Cikl_2:   //    
    INC ECX
    MOV ESI,AdrA
    MOV EAX, DWORD PTR [ESI+ ECX*4]
    MOV ESI,AdrB
    MUL DWORD PTR [ESI+ EBX*4]

    ADD EAX,PP
    ADC EDX,0
    MOV PP,0

    MOV ESI,R
    ADD DWORD PTR [ESI+ EDI*4],EAX
    ADC PP,EDX

    INC EDI

    MOV EAX,AdrA
    CMP ECX, DWORD PTR [EAX]
   JB @M_Cikl_2

    MOV EAX,PP
    ADD DWORD PTR [ESI+ EDI*4],EAX

    MOV EAX,AdrB
    CMP EBX, DWORD PTR [EAX]
   JB @M_Cikl_1


{-------------------------------------------------}
    MOV ESI,R
    MOV ECX,DWORD PTR [ESI]       //  
@M_PROVERKA_RAZMERA:
    CMP DWORD PTR [ESI+ECX*4],0
   LOOPZ @M_PROVERKA_RAZMERA    //  =0
    INC ECX                       // .. ecx -    
    MOV DWORD PTR [ESI],ECX       //    
{-------------------------------------------------}

        POP     EBX
        POP     ESI
        POP     EDI    {   /    }
end;

{====================================================}


{====================================================}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}

procedure umn3(a,b,c:VnTip;var r:VnTip_x2); assembler;
var pp:cardinal;
   AdrA,AdrB,AdrC:LongWord;
   RazmA,RazmB:LongWord;
{  EAX -->    - a     }
{  EDX -->    - b     }
{  ECX -->    - c     }
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX

    MOV AdrA,EAX //   
    MOV AdrB,EDX
    MOV AdrC,ECX
    MOV EAX,DWORD PTR [EAX]
    MOV RazmA,EAX
    MOV EAX,DWORD PTR [EDX]
    MOV RazmB,EAX
        CLD  // -  DI  SI  

{-------------------------------------------------}

    mov edi,r   //    r
    xor eax,eax
    mov ecx,dword ptr NewDl
    inc ecx
  rep stosd            // r[1..NewDl]:=0
{-------------------------------------------------}
    MOV EAX,RazmA          //   
    ADD EAX,RazmB     //    r
    MOV EBX, R
    mov DWORD PTR [EBX], EAX //   r   .  
{
{-------------------------------------------------}
    MOV EBX,0

@M_Cikl_1:

    INC EBX
    MOV ECX,0
    MOV PP,0
    MOV EDI,EBX


@M_Cikl_2:   //    
    INC ECX
    MOV ESI,AdrA
    MOV EAX, DWORD PTR [ESI+ ECX*4]
    MOV ESI,AdrB
    MUL DWORD PTR [ESI+ EBX*4]

    ADD EAX,PP
    ADC EDX,0
    MOV PP,0

    MOV ESI,R
    ADD DWORD PTR [ESI+ EDI*4],EAX
    ADC PP,EDX

    INC EDI

    MOV EAX,AdrA
    CMP ECX, DWORD PTR [EAX]
   JB @M_Cikl_2

    MOV EAX,PP
    ADD DWORD PTR [ESI+ EDI*4],EAX

    MOV EAX,AdrB
    CMP EBX, DWORD PTR [EAX]
   JB @M_Cikl_1


{-------------------------------------------------}
    MOV ESI,R
    MOV ECX,DWORD PTR [ESI]       //  
@M_PROVERKA_RAZMERA:
    CMP DWORD PTR [ESI+ECX*4],0
   LOOPZ @M_PROVERKA_RAZMERA    //  =0
    INC ECX                       // .. ecx -    
    MOV DWORD PTR [ESI],ECX       //    
{-------------------------------------------------}
        POP     EBX
        POP     ESI
        POP     EDI    {   /    }
end;

{====================================================}

{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}

{====================================================}

procedure otn(a,b:VnTip;var c:VnTip;var ost:VnTip); assembler;
{  EAX -->    - a             ESI  }
{  EDX -->    - b             EDX  }
{  ECX -->    - c  -   EBX  }
{         ESI  -     ost       }
{   R[a]= M+N +1    }
{   R[b]= N         }
{   R[c]= M+1       }
{   R[ost]= N       }

var vm2:array[0..NewDl] of longword;
    d,K,P:longword;
    Bn,Bn1:longword;
    AdrA,AdrB,AdrC: longword;
    Ra,Rb,Rc,Rost:LongWord;

asm

        PUSHAD     //  

    mov ESI,eax  //   
    mov EBX,ecx
        CLD  // -  DI  SI  
{--------------------------------------------------------}
    MOV AdrA,EAX
    MOV AdrB,EDX   //    
    MOV AdrC,ECX   // Ost  -  

    MOV EAX,DWORD PTR [EAX]      //  
    MOV Ra,EAX
    MOV EAX,DWORD PTR [EDX]
    MOV Rb,EAX
{--------------------------------------------------------}
           // 

    mov edi,AdrC //ebx   //    c
    mov eax,1
    STOSD                              // C[0]:=1  = 
    mov ecx,dword ptr NewDl            //   
    XOR EAX,EAX
  rep stosd            // c[1..NewDl]:=0

    mov edi,ost   //    ost
    mov eax,1
    STOSD                              // Ost[0]:=1  = 
    mov ecx,dword ptr NewDl            //   
    XOR EAX,EAX
  rep stosd           // ost[1..NewDl]:=0

        //    ost
    MOV ESI,AdrA
    MOV EDI,ost
    MOV ECX,DWORD PTR [ESI]   //    
    INC ECX                   //  
   REP MOVSD

//             OST,     !!!!!!
    MOV EAX,Rb      //    
    CMP Ra,EAX      //   ()   
   JB @M_A_MEN_B //    ,    
{O.K.--------------------------------------------------------}
                    // 
                   //  d  ( -  )

{  X = EAX       y = EBX       c = ECX     n = EDX }

    MOV EAX,[EDX]
    LEA EAX,[EDX+EAX*4]
    MOV EAX,[EAX]

    mov EDX, 32
    MOV ECX, 16
                       //    
                       //     
@M_C_NOT_ZERO:
    CMP ECX,0
   JE @M_C_ZERO
    MOV EBX,EAX
    SHR EBX,CL
    CMP EBX,0
   JE @M_Y_ZERO
    SUB EDX,ECX
    MOV EAX,EBX
@M_Y_ZERO:
    SHR ECX,1
   JMP @M_C_NOT_ZERO
@M_C_ZERO:
    MOV EBX,EAX
    SHR EBX,31
    SUB EDX,EBX
    SUB EDX,EAX
    MOV EAX,EDX

    MOV D,EAX        //  d

{--------------------------------------------------------}

        //    ECX  ,
        //   
        //   A[N+M+1]
    MOV ESI,OST
    MOV EDI,ESI
    LODSD
    INC EAX     //    1,    A[N+M+1]
    STOSD       //   

{     d=0,           }
    CMP D,0
   JE @M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VLEVO

    MOV EBX,D                      //  - 
    DEC EAX                        // .. EDI  ESI   4
    mov ECX,EAX                    //  (   = N+M+1) -1
    LEA EDI,[EDI+EAX*4]      //  [Ra+1]
    DEC EAX
    LEA ESI,[ESI+EAX*4]      //  [Ra]
    STD// ESI EDI 

@M_NORM_SDVIG_A:
        PUSH ECX  // 
    LODSD         //  
    mov ECX,EBX  // -      // EAX - 
    SHLD dword ptr [edi],EAX,CL   //    A[N+M]>>>A[N+M+1]
    dec EDI
    dec EDI
    dec EDI
    dec EDI
        POP ECX
   LOOP @M_NORM_SDVIG_A

    MOV ECX,EBX               //   ()  [1]
    SHL DWORD PTR [EDI],CL

{-------------------------------------------------------}

        //  B  ECX  ,
        //     [N+1]    !!!!!
    MOV ESI,AdrB
    LODSD           //     = N
    MOV EBX,D  //  - 

  {.      1,   }

    LEA EDI,[ESI+EAX*4+4] //  B[n] // +4 . ESI   LODSD
    LEA ESI,[ESI+EAX*4] //  B[n-1]  // 
    DEC EAX
    MOV ECX,EAX    //    32-  ,(  B = N) -1
    //     1,  =0, ..    =2^32
    //        
    CMP ECX,0
   JE @SDVIG_B_RAZMEROM_RAV_1
@M_NORM_SDVIG_B:
        PUSH ECX              // 
    LODSD                     //  
    mov ECX,EBX               // - 
    SHLD dword ptr [edi],EAX,CL  // EAX - 
                  //    A[N+M]>>>A[N+M+1]
    dec EDI
    dec EDI
    dec EDI
    dec EDI
        POP ECX
   LOOP @M_NORM_SDVIG_B

@SDVIG_B_RAZMEROM_RAV_1:
    MOV ECX,EBX               //   ()  B[1]
    SHL DWORD PTR [EDI],CL

{     d=0,           }
@M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VLEVO:
 {--------------------------------------------------------}
     //    B[n]    B[n-1]

    MOV EDX,AdrB
    MOV EAX,DWORD PTR [EDX]
    LEA EAX,[EDX+EAX*4]          //  [n]
    MOV EBX,DWORD PTR [EAX]      //  B[n]
    MOV Bn,EBX
    MOV EBX,DWORD PTR [EAX-4]      //  B[n-1]
    MOV Bn1,EBX

 {--------------------------------------------------------}
        {    }
    MOV ECX,Ra
    SUB ECX,Rb
    INC  ECX             // J:= (Ra+1) - Rb
                     //    +1 
{-----------------------------------------------------------}

//         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@M_OSNOVNOY_CIKL:
          {========  3 ==========}
          //    q
             {--------------------------}
        //  q^:= ( A[j+n] * MaxZnach + A[j+n-1] )  div  B[n]
        //  r^:= ( A[j+n] * MaxZnach + A[j+n-1] )  mod  B[n]

    MOV ESI,Ost
    MOV EAX,Rb                       //     n
    ADD EAX,ECX                      // = n+j
    MOV EDX,DWORD PTR [ESI+EAX*4]           // [j+n]
    MOV EAX,DWORD PTR [ESI+EAX*4-4]           //  [j+n-1]

      {----------------------------------------------------------}
        {   q^}
        
    ////  if q^=>MaxZnach            B[N]<=A[N+J]   
                                                   //  
    CMP Bn,EDX                  //    B[N]  A[N+J]
   JA @M_A_MOGNO_DELIT_NA_B              //   B[N] > A[N+J]

        PUSH ECX
    MOV EBX,EDX       // [j+n]
    MOV ECX,EAX       // [j+n-1]
    XOR EAX,EAX       // q^:= 0 ////MaxZn -1
    DEC EAX           // q^:= MaxZn -1
    MUL Bn            // EDX:EAX = q^ * Bn
    // EDX .. = [j+n] ,  (EBX-EDX)=0    
    // r^ = (EBX-EDX)*MaxZn + (ECX-EAX) ,   EBX=[j+n-1]
    //  (EBX-EDX)>0  r^>MaxZn ,    q^
    SUB ECX,EAX
    SUB EBX,EDX
    MOV EDX,EBX           // = r^
    XOR EAX,EAX       // q^:= 0 ////MaxZn -1
    DEC EAX           // q^:= MaxZn -1
        POP ECX
    CMP EBX,0
   JNE @M_SHAG_4     //  (EBX-EDX)>0  r^>MaxZn,    q^
   JMP @M_NACHALO_OCENKI_q
   
@M_A_MOGNO_DELIT_NA_B:
    DIV Bn      //  
                   //     q^=EAX
                   //           r^=EDX

 {----------------------------------------------------------}
  {    = 1,     q^,
      ,  Ra+1>Rb  
   Ra+1=2 (     A[n+j-2])  
      Rb=1}
    CMP Rb,1
   JE @M_PROPUSK_OCEKI_q_TK_RAZMER_B_RAV_1
  {-------   q^ ---------------}
@M_NACHALO_OCENKI_q:
        PUSH ECX
        PUSH EAX      //    q^
    MOV EBX,AdrB
    MOV ESI,Ost
    MOV EAX,Rb //DWORD PTR [EBX]    // = Rb
    DEC EAX
    DEC EAX                  // = Rb - 2
    ADD EAX,ECX                    // = Rb + J -2
    MOV ECX,DWORD PTR [ESI+EAX*4]      //  =  A [Rb+J-2]
        POP EAX
        PUSH EAX                    // = q^
    MOV EBX,EDX                     // = r^
    MUL Bn1               //  EDX:EAX = q^ * B[ Rb-1 ]
             //   ( q^*B[Rb-1] )   ( r^*MaxZ + A [Rb+J-2] )
             //              EDX:EAX             EBX:ECX
             //  ( q^*B[Rb-1] )    ( r^*MaxZ + A [Rb+J-2] ),
             //  q - 
    CMP EDX,EBX
   JA @q_NE_VERNO           //   EDX > EBX
   JB @M_q_Ok               //   EDX < EBX
    CMP EAX,ECX             //   EDX = EBX
   JA @q_NE_VERNO           //   EAX > ECX
   JMP @M_q_Ok              //   EAX <= ECX

@q_NE_VERNO:
        POP EAX
        POP ECX
    DEC EAX                   //  q^:= q^-1
    MOV EDX,EBX               // =r^
    ADD EDX,Bn                //  r^:= r^+B[Rb]
   JNC @M_NACHALO_OCENKI_q     //     CF=0 , .. r^<MaxZ
        PUSH ECX
        PUSH EAX
@M_q_Ok:
        POP EAX
        POP ECX
{-----------------------------------------------------------}
@M_SHAG_4:
@M_PROPUSK_OCEKI_q_TK_RAZMER_B_RAV_1:
          {=========  4 ===============}
       {  q^*B   }
       { A[ J .. J+Rb+1] - q^ * B[ 1 .. Rb] }
        PUSH ECX
    MOV ESI,Ost
    MOV EDI,AdrB
    MOV EBX,0            // = I =0,    1
    MOV P,0              //  = 0
@M_CIKL_VICH_q:
    INC EBX              // = I   = 1 .. Rb
    INC ECX              // = I+J = j+1 .. j+Rb
        PUSH EAX         // = q^

    MUL DWORD PTR [EDI+EBX*4]           // EDX:EAX = q^ * B[I]
    ADD EAX,P                        // + PERENOS(   
    ADC EDX,0                        //    )
    MOV P,0                          //  

    SUB DWORD PTR [ESI+ECX*4-4],EAX // A[J+I-1]:= A[J+I-1] - (q^*B[I] + PERENOS)
    ADC P,EDX                      //      

        POP EAX
    CMP EBX,Rb        // I  ?  Rb
   JB  @M_CIKL_VICH_q                //  I  <  Rb  ,   
                                      //    
        PUSH EAX
    MOV EAX,P                      //   
    MOV P,0
    SUB DWORD PTR [ESI+ECX*4],EAX  //     A[Rb+J]
                              // 
    ADC P,0          //    
        POP EAX       // = q^
        POP ECX       // = J
{-------------------------------------------------}
             {==========  5 =================}
             //  
    CMP P,0
   JE @M_PROPUSK_KOMPENSACII  //  CF=0 , ..    
        PUSH EAX          // = q^
        PUSH ECX          // = J
    LEA ESI,[ESI+ECX*4]      //   A[J]  
    MOV EDI,ESI              //   A[J]  
    MOV ECX,Rb //[EDI]            // = Rb  ,  
    MOV EDX,AdrB //EDI              //  = Adres B
    clc       //   
    CLD       //    EDI  ESI

@M_CIKL_KOMPENSACIYA:
    inc EDX        //    
    inc EDX
    inc EDX
    inc EDX
    LODSD         // 
    ADC EAX,dword ptr [EDX]  //
    //         
    stosd         //  
   loop @M_CIKL_KOMPENSACIYA
    LODSD
    ADC EAX,0      //     [J+Rb]
    STOSD
        POP ECX                       // = J
        POP EAX                       // = q^
    //   A[J+Rb+1] , ..     
    DEC EAX                           // q^ := q^ - 1
{-------------------------------------------------}
     {=========  6 ============}
@M_PROPUSK_KOMPENSACII:
    MOV EDX,AdrC                       //   
    ADD DWORD PTR [EDX+ECX*4],EAX      // C[J] := C[J] + q^
//    MOV DWORD PTR [EDX+ECX*4],EAX      // C[J] := q^
{-------------------------------------------------}
     {=========  7 ============}
    DEC ECX
    CMP ECX,0
   JA @M_OSNOVNOY_CIKL


//             @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

{     d=0,           }
    CMP D,0
   JE @M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VPRAVO

        //    d  ,

    mov ECX,DWORD PTR [ESI] //   //  =  
    DEC ECX
    XOR EAX,EAX
    CMP ECX,EAX //0
   JE @M_RAZMER_A_MEN_1
@M_SDV_VPRAVO:
        PUSH ECX
        MOV ECX,D                        //   
    INC EAX     // EAX + 1
    MOV EBX,DWORD PTR [ESI+EAX*4+4]
    SHRD DWORD PTR [ESI+EAX*4],EBX,CL      //   EAX- 
        POP ECX
   LOOP @M_SDV_VPRAVO
@M_RAZMER_A_MEN_1:
    MOV ECX,D
    SHR DWORD PTR [ESI+EAX*4+4],CL //    

    MOV ECX,DWORD PTR [ESI]       //   
@M_RAZMER_A_POSLE_NORMALIZ_OK:
    CMP DWORD PTR [ESI+ECX*4],0
   LOOPZ @M_RAZMER_A_POSLE_NORMALIZ_OK    //  =0
    INC ECX                       // .. ecx -    
    MOV DWORD PTR [ESI],ECX       //    

{-----------------------------------------------------------}
        //    d  ,

    MOV ESI,AdrB
    mov ECX,DWORD PTR [ESI] //   //  =  
    DEC ECX               //    1
    XOR EAX,EAX
    CMP ECX,EAX //0
   JE @M_RAZMER_B_MEN_1
@M_SDV_VPRAVO_DELIT:
        PUSH ECX
        MOV ECX,D                        //   
    INC EAX
    MOV EBX,DWORD PTR [ESI+EAX*4+4]
    SHRD DWORD PTR [ESI+EAX*4],EBX,CL      //   EAX- 
        POP ECX
   LOOP @M_SDV_VPRAVO_DELIT
@M_RAZMER_B_MEN_1:
    MOV ECX,D
    SHR DWORD PTR [ESI+EAX*4+4],CL //    

{     d=0,           }
@M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VPRAVO:

{-----------------------------------------------------------}
    {  }

    MOV ESI,AdrA
    MOV ECX,DWORD PTR [ESI]       //   
    MOV ESI,AdrC
@M_PROVERKA_RAZMERA_Chastnogo:
    CMP DWORD PTR [ESI+ECX*4],0
   LOOPZ @M_PROVERKA_RAZMERA_Chastnogo    //  =0
    INC ECX                       // .. ecx -    
    MOV DWORD PTR [ESI],ECX       //    

{-------------------------------------------------------}
    {  }
    MOV ESI,Ost
    MOV ECX,DWORD PTR [ESI]       //   
@M_PROVERKA_RAZMERA_A:
    CMP DWORD PTR [ESI+ECX*4],0
   LOOPZ @M_PROVERKA_RAZMERA_A    //  =0
    INC ECX                       // .. ecx -    
    MOV DWORD PTR [ESI],ECX       //    
{--------------------------------------------------------}
{-----------------------------------------------------------}

@M_A_MEN_B:  //  !!!!!!!!   

        POPAD
        CLD   // -  DI  SI  
end;
{====================================================}
 {   Otn}
{====================================================}



{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}

procedure modul(var a:VnTip;b:VnTip); assembler;
//procedure otn2(a,b:VnTip;var c:VnTip;var ost:VnTip); assembler;
{  : a    b }
{  EAX -->    - a             ESI  }
{  EDX -->    - b             EDX  }
{  ECX -->    - c  -   EBX  }
{   R[a]= M+N +1    }
{   R[b]= N         }

var vm2:array[0..NewDl] of longword;
    d,K,P:longword;
    Bn,Bn1:longword;
    AdrA,AdrB: longword;
    Ra,Rb:LongWord;

asm
        PUSHAD     //  
        CLD  // -  DI  SI  
{--------------------------------------------------------}
    MOV AdrA,EAX
    MOV AdrB,EDX   //    

{--------------------------------------------------------}

    mov EAX,dword ptr [EAX]         // 
    cmp EAX,DWORD PTR [EDX]                      //  
   JB @M_A_MEN_B    //  !!!!!!!!   
{--------------------------------------------------------}

     //        

    MOV Ra,EAX                  // 
    MOV EAX,dword ptr [EDX]
    MOV Rb,EAX                  //  

{--------------------------------------------------------}

                    // 
                   //  d  ( -  )
{  X = EAX       y = EBX       c = ECX     n = EDX
    }
    MOV EAX,[EDX]
    LEA EAX,[EDX+EAX*4]
    MOV EAX,[EAX]

    mov EDX, 32
    MOV ECX, 16
                       //    
                       //     
@M_C_NOT_ZERO:
    CMP ECX,0
   JE @M_C_ZERO
    MOV EBX,EAX
    SHR EBX,CL
    CMP EBX,0
   JE @M_Y_ZERO
    SUB EDX,ECX
    MOV EAX,EBX
@M_Y_ZERO:
    SHR ECX,1
   JMP @M_C_NOT_ZERO
@M_C_ZERO:
    MOV EBX,EAX
    SHR EBX,31
    SUB EDX,EBX
    SUB EDX,EAX
    MOV EAX,EDX

    MOV D,EAX        //  d

{O.K.--------------------------------------------------------}
        //    ECX  ,
        //   
        //   A[N+M+1]

    MOV ESI,AdrA
    MOV EDI,ESI
    LODSD
    INC EAX  //     1,    A[N+M+1]
    STOSD //   
    { ..   1 ( ),  min  =2
            
            =1 }

{     d=0,           }
    CMP D,0
   JE @M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VLEVO

    MOV EBX,D  //  - 
    DEC EAX   // .. EDI  ESI   4
    mov ECX,EAX  // (   = N+M+1) -1
    LEA EDI,[EDI+EAX*4] //  [n+m+1]
    DEC EAX
    LEA ESI,[ESI+EAX*4] //  [n+m]
    STD// ESI EDI 

@M_NORM_SDVIG_A:
        PUSH ECX  // 
    LODSD         //  
    mov ECX,EBX  // - 
    SHLD dword ptr [edi],EAX,CL          // EAX-
    dec EDI                     //   A[N+M]>>>A[N+M+1]
    dec EDI
    dec EDI
    dec EDI
        POP ECX
   LOOP @M_NORM_SDVIG_A

    MOV ECX,EBX               //   ()  [1]
    SHL DWORD PTR [EDI],CL

{-------------------------------------------------------}

        //  B  ECX  ,
        //     [N+1]    !!!!!
    MOV ESI,AdrB
    LODSD           //     = N
    MOV EBX,D  //  - 

  {.      1,   }
    LEA EDI,[ESI+EAX*4+4] //  B[n] // +4 . ESI   LODSD
    LEA ESI,[ESI+EAX*4] //  B[n-1]  // 
    DEC EAX
    MOV ECX,EAX    //    32-  ,(  B = N) -1
//     1,  =0, ..    =2^32
//        
    CMP ECX,0
   JE @SDVIG_B_RAZMEROM_RAV_1
@M_NORM_SDVIG_B:
        PUSH ECX              // 
    LODSD                     //  
    mov ECX,EBX               // - 
    SHLD dword ptr [edi],EAX,CL  // EAX - 
                  //    A[N+M]>>>A[N+M+1]
    dec EDI
    dec EDI
    dec EDI
    dec EDI
        POP ECX
   LOOP @M_NORM_SDVIG_B

@SDVIG_B_RAZMEROM_RAV_1:      {     1,   }
    MOV ECX,EBX               //   ()  B[1]
    SHL DWORD PTR [EDI],CL

{     d=0,           }
@M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VLEVO:

     //    B[n]    B[n-1]

    MOV EDX,AdrB

    MOV EAX,DWORD PTR [EDX]
    LEA EAX,[EDX+EAX*4]
    MOV EBX,DWORD PTR [EAX]      //  B[n]
    MOV Bn,EBX
    MOV EBX,DWORD PTR [EAX-4]      //  B[n-1]
    MOV Bn1,EBX

 {O.K.--------------------------------------------------------}
    MOV ECX,Ra
    SUB ECX,Rb
    INC  ECX             // J:= (Ra+1) - Rb
                        //    +1 

//         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@M_OSNOVNOY_CIKL:

          {========  3 ==========}
   //    q
             {--------------------------}
        //  q^:= ( A[j+n] * MaxZnach + A[j+n-1] )  div  B[n]
        //  r^:= ( A[j+n] * MaxZnach + A[j+n-1] )  mod  B[n]

    MOV ESI,AdrA
    MOV EAX,Rb                       //     n
    ADD EAX,ECX                      // = n+j
    MOV EDX,DWORD PTR [ESI+EAX*4]           // [j+n]
    MOV EAX,DWORD PTR [ESI+EAX*4-4]           //  [j+n-1]

      {----------------------------------------------------------}
        {   q^}
        
    ////  if q^=>MaxZnach            B[N]<=A[N+J]   
                                                   //  
    CMP Bn,EDX                  //    B[N]  A[N+J]
   JA @M_A_MOGNO_DELIT_NA_B              //   B[N] > A[N+J]

        PUSH ECX
    MOV EBX,EDX       // [j+n]
    MOV ECX,EAX       // [j+n-1]
    XOR EAX,EAX       // q^:= 0 ////MaxZn -1
    DEC EAX           // q^:= MaxZn -1
    MUL Bn            // EDX:EAX = q^ * Bn
    // EDX .. = [j+n] ,  (EBX-EDX)=0    
    // r^ = (EBX-EDX)*MaxZn + (ECX-EAX) ,   EBX=[j+n-1]
    //  (EBX-EDX)>0  r^>MaxZn ,    q^
    SUB ECX,EAX
    SUB EBX,EDX
    MOV EDX,EBX           // = r^
    XOR EAX,EAX       // q^:= 0 ////MaxZn -1
    DEC EAX           // q^:= MaxZn -1
        POP ECX
    CMP EBX,0
   JNE @M_SHAG_4     //  (EBX-EDX)>0  r^>MaxZn,    q^
   JMP @M_NACHALO_OCENKI_q
   
@M_A_MOGNO_DELIT_NA_B:
    DIV Bn      //  
                   //     q^=EAX
                   //           r^=EDX

 {----------------------------------------------------------}
  {    = 1,     q^,
      ,  Ra+1>Rb  
   Ra+1=2 (     A[n+j-2])  
      Rb=1}
    CMP Rb,1
   JE @M_PROPUSK_OCEKI_q_TK_RAZMER_B_RAV_1
  {-------   q^ ---------------}
@M_NACHALO_OCENKI_q:
        PUSH ECX
        PUSH EAX      //    q^
    MOV EBX,AdrB
    MOV ESI,AdrA
    MOV EAX,Rb //DWORD PTR [EBX]    // = Rb
    DEC EAX
    DEC EAX                  // = Rb - 2
    ADD EAX,ECX                    // = Rb + J -2
    MOV ECX,DWORD PTR [ESI+EAX*4]      //  =  A [Rb+J-2]
        POP EAX
        PUSH EAX                    // = q^
    MOV EBX,EDX                     // = r^
    MUL Bn1               //  EDX:EAX = q^ * B[ Rb-1 ]
             //   ( q^*B[Rb-1] )   ( r^*MaxZ + A [Rb+J-2] )
             //              EDX:EAX             EBX:ECX
             //  ( q^*B[Rb-1] )    ( r^*MaxZ + A [Rb+J-2] ),
             //  q - 
    CMP EDX,EBX
   JA @q_NE_VERNO           //   EDX > EBX
   JB @M_q_Ok               //   EDX < EBX
    CMP EAX,ECX             //   EDX = EBX
   JA @q_NE_VERNO           //   EAX > ECX
   JMP @M_q_Ok              //   EAX <= ECX

@q_NE_VERNO:
        POP EAX
        POP ECX
    DEC EAX                   //  q^:= q^-1
    MOV EDX,EBX               // =r^
    ADD EDX,Bn                //  r^:= r^+B[Rb]

   JnC @M_NACHALO_OCENKI_q     //     CF=0 , .. r<MaxZ
        PUSH ECX
        PUSH EAX
@M_q_Ok:
        POP EAX
        POP ECX
{-----------------------------------------------------------}
{-----------------------------------------------------------}
@M_SHAG_4:
@M_PROPUSK_OCEKI_q_TK_RAZMER_B_RAV_1:
          {=========  4 ===============}
       {  q^*B   }
       { A[ J .. J+Rb+1] - q^ * B[ 1 .. Rb] }
        PUSH ECX
    MOV ESI,AdrA
    MOV EDI,AdrB
    MOV EBX,0                           // = I ,    1
    MOV P,0                             //  = 0
@M_CIKL_VICH_q:
    INC EBX                             // = I  = 1 .. Rb
    INC ECX                             // = I+J = j+1 .. j+Rb
        PUSH EAX                        // =q^

    MUL DWORD PTR [EDI+EBX*4]           // EDX:EAX = q^ * B[I]
    ADD EAX,P                        // + PERENOS(   
    ADC EDX,0                        //    )
    MOV P,0                          //  

    SUB DWORD PTR [ESI+ECX*4-4],EAX //A[I+J-1]:= A[I+J-1] - (q^*B[I] + PERENOS)
    ADC P,EDX                      //      

        POP EAX
    CMP EBX,Rb                  // I     Rb
   JB  @M_CIKL_VICH_q           //  I  <  Rb  ,   
                                //    
        PUSH EAX
    MOV EAX,P
    MOV P,0
    SUB DWORD PTR [ESI+ECX*4],EAX  //     
                                   //   
    ADC P,0
        POP EAX           // = q^
        POP ECX           // = J
{-------------------------------------------------}
             {==========  5 =================}
             //  
    CMP P,0       //      ,  
   JE @M_PROPUSK_KOMPENSACII  //  CF=0 , ..    
        PUSH EAX          // = q^
        PUSH ECX          // = J
    LEA ESI,[ESI+ECX*4]      //   A[J]  
    MOV EDI,ESI              //   A[J]  
    MOV ECX,Rb //[EDI]            // = Rb  ,  
    MOV EDX,AdrB //EDI              //  = Adres B
    clc       //   
    CLD       //    EDI  ESI

@M_CIKL_KOMPENSACIYA:
    inc EDX        //    
    inc EDX
    inc EDX
    inc EDX
    LODSD
    ADC EAX,DWORD PTR [EDX] //        
    STOSD
   loop @M_CIKL_KOMPENSACIYA

    LODSD          //     [J+Rb]  !!!!!!!!?????????
    ADC EAX,0
    STOSD

        POP ECX                       // = J
        POP EAX                       // = q^
    //   A[J+Rb+1] , ..     

    DEC EAX                           // q^ := q^ - 1
{-------------------------------------------------}
     {=========  6 ============}
@M_PROPUSK_KOMPENSACII:
{-------------------------------------------------}
     {=========  7 ============}
    DEC ECX
    CMP ECX,0
   JA @M_OSNOVNOY_CIKL

//             @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

{-----------------------------------------------------------}
    {  }

    MOV ESI,AdrA
    MOV ECX,DWORD PTR [ESI]       //   
@M_PROVERKA_RAZMERA_A:
    CMP DWORD PTR [ESI+ECX*4],0
   LOOPZ @M_PROVERKA_RAZMERA_A    //  =0
    INC ECX                       // .. ecx -    
    MOV DWORD PTR [ESI],ECX       //    

{     d=0,           }
    CMP D,0
   JE @M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VPRAVO

        //    d  ,

    mov ECX,DWORD PTR [ESI] //   //  =  
    DEC ECX
    XOR EAX,EAX
    CMP ECX,EAX //0
   JE @M_RAZMER_A_MEN_1
@M_SDV_VPRAVO:
        PUSH ECX
        MOV ECX,D                        //   
    INC EAX     // EAX + 1
    MOV EBX,DWORD PTR [ESI+EAX*4+4]
    SHRD DWORD PTR [ESI+EAX*4],EBX,CL      //   EAX- 
        POP ECX
   LOOP @M_SDV_VPRAVO
@M_RAZMER_A_MEN_1:
    MOV ECX,D
    SHR DWORD PTR [ESI+EAX*4+4],CL //    

    MOV ECX,DWORD PTR [ESI]       //   
@M_RAZMER_A_POSLE_NORMALIZ_OK:
    CMP DWORD PTR [ESI+ECX*4],0
   LOOPZ @M_RAZMER_A_POSLE_NORMALIZ_OK    //  =0
    INC ECX                       // .. ecx -    
    MOV DWORD PTR [ESI],ECX       //    

{-----------------------------------------------------------}
        //    d  ,

    MOV ESI,AdrB
    mov ECX,DWORD PTR [ESI] //   //  =  
    DEC ECX               //    1
    XOR EAX,EAX
    CMP ECX,EAX //0
   JE @M_RAZMER_B_MEN_1
@M_SDV_VPRAVO_DELIT:
        PUSH ECX
        MOV ECX,D                        //   
    INC EAX
    MOV EBX,DWORD PTR [ESI+EAX*4+4]
    SHRD DWORD PTR [ESI+EAX*4],EBX,CL      //   EAX- 
        POP ECX
   LOOP @M_SDV_VPRAVO_DELIT
@M_RAZMER_B_MEN_1:
    MOV ECX,D
    SHR DWORD PTR [ESI+EAX*4+4],CL //    

{     d=0,           }
@M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VPRAVO:

{-----------------------------------------------------------}

@M_A_MEN_B:  //  !!!!!!!!   
        POPAD
CLD   // -  DI  SI  
end;
{====================================================}
 {   modul}
{====================================================}

{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}

procedure modul2(var a:VnTip_x2;b:VnTip;KolSdv:Cardinal); assembler;
{  EAX -->    - a                       - ESI  }
{  EDX -->   b -    Sdvig - EDX  }
{  ECX -->   KolSdv -     }
{   R[a]= M+N +1    }
{   R[b]= N         }

var vm2:array[0..NewDl] of longword;
    d,K,P:longword;
    Bn,Bn1:longword;
    AdrA,AdrB: longword;
    Ra,Rb:LongWord;

asm
        PUSHAD     //  

        CLD  // -  DI  SI  
{--------------------------------------------------------}
    MOV AdrA,EAX
    MOV AdrB,EDX   //    
    MOV D,ECX

{--------------------------------------------------------}

    mov EAX,dword ptr [EAX]         // 
    cmp EAX,DWORD PTR [EDX]                      //  
   JB @M_A_MEN_B    //  !!!!!!!!   
{--------------------------------------------------------}

     //        

    MOV Ra,EAX                  // 
    MOV EAX,dword ptr [EDX]
    MOV Rb,EAX                  //  

{-------------------------------------------------------}
              //    -     
{--------------------------------------------------------}
        //    ECX  ,
        //   
        //   A[N+M+1]

    MOV ESI,AdrA
    MOV EDI,ESI
    LODSD
    INC EAX  //     1,    A[N+M+1]
    STOSD //   
    { ..   1 ( ),  min  =2
            
            =1 }

{     d=0,           }
    CMP D,0
   JE @M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VLEVO

    MOV EBX,D  //  - 
    DEC EAX   // .. EDI  ESI   4
    mov ECX,EAX  // (   = N+M+1) -1
    LEA EDI,[EDI+EAX*4] //  [n+m+1]
    DEC EAX
    LEA ESI,[ESI+EAX*4] //  [n+m]
    STD// ESI EDI 

@M_NORM_SDVIG_A:
        PUSH ECX  // 
    LODSD         //  
    mov ECX,EBX  // - 
    SHLD dword ptr [edi],EAX,CL          // EAX-
    dec EDI                     //   A[N+M]>>>A[N+M+1]
    dec EDI
    dec EDI
    dec EDI
        POP ECX
   LOOP @M_NORM_SDVIG_A

    MOV ECX,EBX               //   ()  [1]
    SHL DWORD PTR [EDI],CL

{--------------------------------------------------------}
    //  B  ECX   -    
{--------------------------------------------------------}
{     d=0,           }
@M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VLEVO:

     //    B[n]    B[n-1]

    MOV EDX,AdrB

    MOV EAX,DWORD PTR [EDX]
    LEA EAX,[EDX+EAX*4]
    MOV EBX,DWORD PTR [EAX]      //  B[n]
    MOV Bn,EBX
    MOV EBX,DWORD PTR [EAX-4]      //  B[n-1]
    MOV Bn1,EBX

 {--------------------------------------------------------}
    MOV ECX,Ra
    SUB ECX,Rb
    INC  ECX             // J:= (Ra+1) - Rb
         // J:= M+1 .. 1  ; // J       
                        //    +1 

//         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@M_OSNOVNOY_CIKL:

          {========  3 ==========}
   //    q
             {--------------------------}
        //  q^:= ( A[j+n] * MaxZnach + A[j+n-1] )  div  B[n]
        //  r^:= ( A[j+n] * MaxZnach + A[j+n-1] )  mod  B[n]

    MOV ESI,AdrA
    MOV EAX,Rb                       //     n
    ADD EAX,ECX                      // = n+j
    MOV EDX,DWORD PTR [ESI+EAX*4]           // [j+n]
    MOV EAX,DWORD PTR [ESI+EAX*4-4]           //  [j+n-1]

      {----------------------------------------------------------}
        {   q^}
        
    ////  if q^=>MaxZnach            B[N]<=A[N+J]   
                                                   //  
    CMP Bn,EDX                  //    B[N]  A[N+J]
   JA @M_A_MOGNO_DELIT_NA_B              //   B[N] > A[N+J]

        PUSH ECX
    MOV EBX,EDX       // [j+n]
    MOV ECX,EAX       // [j+n-1]
    XOR EAX,EAX       // q^:= 0 ////MaxZn -1
    DEC EAX           // q^:= MaxZn -1
    MUL Bn            // EDX:EAX = q^ * Bn
    // EDX .. = [j+n] ,  (EBX-EDX)=0    
    // r^ = (EBX-EDX)*MaxZn + (ECX-EAX) ,   EBX=[j+n-1]
    //  (EBX-EDX)>0  r^>MaxZn ,    q^
    SUB ECX,EAX
    SUB EBX,EDX
    MOV EDX,EBX           // = r^
    XOR EAX,EAX       // q^:= 0 ////MaxZn -1
    DEC EAX           // q^:= MaxZn -1
        POP ECX
    CMP EBX,0
   JNE @M_SHAG_4     //  (EBX-EDX)>0  r^>MaxZn,    q^
   JMP @M_NACHALO_OCENKI_q
   
@M_A_MOGNO_DELIT_NA_B:
    DIV Bn      //  
                   //     q^=EAX
                   //           r^=EDX

 {----------------------------------------------------------}
  {    = 1,     q^,
      ,  Ra+1>Rb  
   Ra+1=2 (     A[n+j-2])  
      Rb=1}
    CMP Rb,1
   JE @M_PROPUSK_OCEKI_q_TK_RAZMER_B_RAV_1
  {-------   q^ ---------------}
@M_NACHALO_OCENKI_q:
        PUSH ECX
        PUSH EAX      //    q^
    MOV EBX,AdrB
    MOV ESI,AdrA
    MOV EAX,Rb //DWORD PTR [EBX]    // = Rb
    DEC EAX
    DEC EAX                  // = Rb - 2
    ADD EAX,ECX                    // = Rb + J -2
    MOV ECX,DWORD PTR [ESI+EAX*4]      //  =  A [Rb+J-2]
        POP EAX
        PUSH EAX                    // = q^
    MOV EBX,EDX                     // = r^
    MUL Bn1               //  EDX:EAX = q^ * B[ Rb-1 ]
             //   ( q^*B[Rb-1] )   ( r^*MaxZ + A [Rb+J-2] )
             //              EDX:EAX             EBX:ECX
             //  ( q^*B[Rb-1] )    ( r^*MaxZ + A [Rb+J-2] ),
             //  q - 
    CMP EDX,EBX
   JA @q_NE_VERNO           //   EDX > EBX
   JB @M_q_Ok               //   EDX < EBX
    CMP EAX,ECX             //   EDX = EBX
   JA @q_NE_VERNO           //   EAX > ECX
   JMP @M_q_Ok              //   EAX <= ECX

@q_NE_VERNO:
        POP EAX
        POP ECX
    DEC EAX                   //  q^:= q^-1
    MOV EDX,EBX               // =r^
    ADD EDX,Bn                //  r^:= r^+B[Rb]

   JnC @M_NACHALO_OCENKI_q     //     CF=0 , .. r<MaxZ
        PUSH ECX
        PUSH EAX
@M_q_Ok:
        POP EAX
        POP ECX
{-----------------------------------------------------------}
{-----------------------------------------------------------}
@M_SHAG_4:
@M_PROPUSK_OCEKI_q_TK_RAZMER_B_RAV_1:
          {=========  4 ===============}
       {  q^*B   }
       { A[ J .. J+Rb+1] - q^ * B[ 1 .. Rb] }
        PUSH ECX
    MOV ESI,AdrA
    MOV EDI,AdrB
    MOV EBX,0                           // = I ,    1
    MOV P,0                             //  = 0
@M_CIKL_VICH_q:
    INC EBX                             // = I  = 1 .. Rb
    INC ECX                             // = I+J = j+1 .. j+Rb
        PUSH EAX                        // =q^

    MUL DWORD PTR [EDI+EBX*4]           // EDX:EAX = q^ * B[I]
    ADD EAX,P                        // + PERENOS(   
    ADC EDX,0                        //    )
    MOV P,0                          //  

    SUB DWORD PTR [ESI+ECX*4-4],EAX //A[I+J-1]:= A[I+J-1] - (q^*B[I] + PERENOS)
    ADC P,EDX                      //      

        POP EAX
    CMP EBX,Rb                  // I     Rb
   JB  @M_CIKL_VICH_q           //  I  <  Rb  ,   
                                //    
        PUSH EAX
    MOV EAX,P
    MOV P,0
    SUB DWORD PTR [ESI+ECX*4],EAX  //     
                                   //   
    ADC P,0
        POP EAX           // = q^
        POP ECX           // = J
{-------------------------------------------------}
             {==========  5 =================}
             //  
    CMP P,0       //      ,  
   JE @M_PROPUSK_KOMPENSACII  //  CF=0 , ..    
        PUSH EAX          // = q^
        PUSH ECX          // = J
    LEA ESI,[ESI+ECX*4]      //   A[J]  
    MOV EDI,ESI              //   A[J]  
    MOV ECX,Rb //[EDI]            // = Rb  ,  
    MOV EDX,AdrB //EDI              //  = Adres B
    clc       //   
    CLD       //    EDI  ESI

@M_CIKL_KOMPENSACIYA:
    inc EDX        //    
    inc EDX
    inc EDX
    inc EDX
    LODSD
    ADC EAX,DWORD PTR [EDX] //        
    STOSD
   loop @M_CIKL_KOMPENSACIYA

    LODSD          //     [J+Rb]  !!!!!!!!?????????
    ADC EAX,0
    STOSD

        POP ECX                       // = J
        POP EAX                       // = q^
    //   A[J+Rb+1] , ..     

    DEC EAX                           // q^ := q^ - 1
{-------------------------------------------------}
     {=========  6 ============}
@M_PROPUSK_KOMPENSACII:
{-------------------------------------------------}
     {=========  7 ============}
    DEC ECX
    CMP ECX,0
   JA @M_OSNOVNOY_CIKL     //   LOOP


//             @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

{-----------------------------------------------------------}
    {  }

    MOV ESI,AdrA
    MOV ECX,DWORD PTR [ESI]       //   
@M_PROVERKA_RAZMERA_A:
    CMP DWORD PTR [ESI+ECX*4],0
   LOOPZ @M_PROVERKA_RAZMERA_A    //  =0
    INC ECX                       // .. ecx -    
    MOV DWORD PTR [ESI],ECX       //    

{     d=0,           }
    CMP D,0
   JE @M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VPRAVO

        //    d  ,

    mov ECX,DWORD PTR [ESI] //   //  =  
    DEC ECX
    XOR EAX,EAX
    CMP ECX,EAX //0
   JE @M_RAZMER_A_MEN_1
@M_SDV_VPRAVO:
        PUSH ECX
        MOV ECX,D                        //   
    INC EAX
    MOV EBX,DWORD PTR [ESI+EAX*4+4]
    SHRD DWORD PTR [ESI+EAX*4],EBX,CL      //   EAX- 
        POP ECX
   LOOP @M_SDV_VPRAVO
@M_RAZMER_A_MEN_1:
    MOV ECX,D
    SHR DWORD PTR [ESI+EAX*4+4],CL //    

    MOV ECX,DWORD PTR [ESI]       //   
@M_RAZMER_A_POSLE_NORMALIZ_OK:
    CMP DWORD PTR [ESI+ECX*4],0
   LOOPZ @M_RAZMER_A_POSLE_NORMALIZ_OK    //  =0
    INC ECX                       // .. ecx -    
    MOV DWORD PTR [ESI],ECX       //    

{-----------------------------------------------------------}
{O.K.--------------------------------------------------------}
        //    d  , -  

        {     d=0,           }
@M_PROPYSK_SDVIG_NORMALIZACIYA_A_B_VPRAVO:

{-----------------------------------------------------------}

@M_A_MEN_B:  //  !!!!!!!!   

        POPAD
CLD   // -  DI  SI  
end;
{====================================================}
 {   modul2}
{====================================================}


{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}

function A_MEN_B(a,b:VnTip):integer; assembler;
var Rezalt:LongWord;
asm
pushad

   mov ebx,[edx]
   cmp [eax],ebx  // 
  ja @Met_A_bol
  jb @Met_B_bol

   lea edi,[edx+ebx*4]
   mov ecx,[eax]
   lea esi,[eax+ecx*4]
   std     //  esi  edi - 
//   cld
   mov ecx,[eax]
  repe cmpsd          //     
  ja @Met_A_bol
  jb @Met_B_bol


   mov eax,0        // A=B    R = 0
  jmp @M_End
@Met_B_bol:        //A<B      R = 1
   mov eax,1
  jmp @M_End
@Met_A_bol:         //A>B     R = 2
   mov eax,2
@M_End:

MOV Rezalt,eax

   cld   //  esi  edi 
   popad

MOV EAX,Rezalt
end;

function Mod2(n:VnTip):integer;
{        2   }
begin
  Mod2:=n[1] mod 2;
end;

procedure Div2(var A:VnTip);
{        2    }
var aa:Vntip;
asm

    //    1 
    mov esi,eax
    CMP dword ptr [esi],1 //    A = 1
   JA @M_NACH
    SHR dword ptr [ESI+4],1  //   A[N]>>>A[N-1]
   JMP @M_RAZM_A_1

@M_NACH:

        PUSH ESI
    LODSD  //EAX = N ,  A,    = (N-1)
    DEC EAX        // EAX = N-1
    MOV ECX,EAX  // = N - 1 //        
    MOV EDI,ESI  //    
    INC ESI     //      
    INC ESI
    INC ESI
    INC ESI
@M_CIKL_DIV:
    LODSD         //  
    SHRD dword ptr [edi],EAX,1  //EAX -,   OST[N]>>>OST[N-1]
    INC EDI
    INC EDI
    INC EDI
    INC EDI
   LOOP @M_CIKL_DIV
    SHR DWORD PTR [EDI],1      //   ()  A[N]

        POP ESI
     //      
    MOV EAX,DWORD PTR [ESI]
    CMP DWORD PTR [ESI+EAX],0
   JNE @M_PROP_UMEN
    DEC DWORD PTR [ESI]
@M_PROP_UMEN:

@M_RAZM_A_1:

end;

Function A_rav_0(a:VnTip):boolean;
asm
      mov esi,eax
      mov ecx,dword ptr [esi] // 
@metka:
   lea eax,[eax+4]
   cmp [eax],0
  loope  @metka
   mov eax,1
  je @m_ravn
   mov eax,0
@m_ravn:

end;
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}



procedure Stepen(a,n,c:VnTip;var r : VnTip);
// A  v stepeni N po modulu C
// r - rezultat
 var  i: integer;
      y,z,prom,nn: VnTip;
//      z1:VnTip;
begin
  {========  BEGIN  STEPEN  ============================}
  for i:= 1 to NewDl do
         y[i]:=0;
  y[0]:=1;
  y[1]:=1;
  nn:=n;
  z:=a;

  Repeat
     if (Mod2(nn)=1) then
        begin
          UmnMod(y,z,c,prom);
          y:= prom;
        end;
     Div2(nn);
     if not A_rav_0(nn) then
        begin
//          z1:=z;
          UmnMod(z,z{1},c,prom);
          z:=prom;
        end;
  Until A_rav_0(nn);

  r:=y;
  {========  END  STEPEN  ===============================}
end;

{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}

procedure sdvig(d:cardinal;var m:VnTip);
{ d -- eax}
{ m -- edx}
asm

        //  B  ECX  ,
        //     [N+1]    !!!!!

    STD// ESI EDI 

    MOV EBX,eax  //  - 
    MOV ESI,edx
    LODSD           //     = N

  {.      1,   }
    LEA EDI,[ESI+EAX*4+4] //  B[n] // +4 . ESI   LODSD
    LEA ESI,[ESI+EAX*4] //  B[n-1]  // 

    DEC EAX
    MOV ECX,EAX    //    32-  ,(  B = N) -1
//     1,  =0, ..    =2^32
//        
    CMP ECX,0
   JE @SDVIG_B_RAZMEROM_RAV_1
@M_NORM_SDVIG_B:
        PUSH ECX              // 
    LODSD                     //  
    mov ECX,EBX               // - 
    SHLD dword ptr [edi],EAX,CL  // EAX - 
                  //    A[N+M]>>>A[N+M+1]
    dec EDI
    dec EDI
    dec EDI
    dec EDI
        POP ECX
   LOOP @M_NORM_SDVIG_B

@SDVIG_B_RAZMEROM_RAV_1:      {     1,   }
    MOV ECX,EBX               //   ()  B[1]
    SHL DWORD PTR [EDI],CL

    CLD // ESI EDI - 
end;

{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}

{===============================================================}
procedure SlogMod(a,b,c:VnTip;var r:VnTip);
var r1,c1: VnTip;
begin
  Slog(a,b,c,r);
  if A_men_B(r,c)<>1 then       //   >=   
    begin
     razn(r,c,c1,r1);
     r:=r1;
    end;

end;
{=================================================================}
procedure RaznMod(a,b,c:VnTip;var r:VnTip);
var a1,b1,c1,r1:VnTip;
begin
  if A_men_B(a,b)=1 then       //   <    
    begin
     Slog(a,c,c1,a1);
     Razn(a1,b,c,r);
    end
   else  Razn(a,b,c,r);
end;
{=================================================================}
procedure UmnMod(a,b,c:VnTip;var r:VnTip);
var t:VnTip_x2;
    d: cardinal;
begin
    Umn2(a,b,c,t);
  if t[0]>=c[0] then
    begin
       d:=nlz(c[c[0]]); {      - }
       {  - }
       sdvig(d,c);
       modul2(t,c,d);
    end;
  X2ToMas(t,r);

end;

{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}
{nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn}

procedure Stepen2(a,n,c:VnTip;var r : VnTip);
// A  v stepeni N po modulu C
// r - rezultat
 var  i: integer;
      d: Cardinal;
      y,z,z1,nn: VnTip;
      prom: VnTip_x2;
begin
  {========  BEGIN  STEPEN  ============================}
  for i:= 1 to NewDl do
         y[i]:=0;
  y[0]:=1;
  y[1]:=1;
  nn:=n;
  z:=a;

    { -}
  d:=nlz(c[c[0]]);   {      - }
    {  - }
  sdvig(d,c);

  Repeat
     if (Mod2(nn)=1) then
        begin
          Umn2(y,z,c,prom);
          if prom[0]>=c[0] then  modul2(prom,c,d);
          x2ToMas(prom,y);
        end;
     Div2(nn);
     if not A_rav_0(nn) then
        begin
          Umn2(z,z{1},c,prom);
          if prom[0]>=c[0] then  modul2(prom,c,d);
          x2ToMas(prom,z);
        end;
  Until A_rav_0(nn);

  r:=y;
  {========  END  STEPEN  ===============================}
end;

{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{====================================================}

function nlz(x:cardinal):cardinal;
{  X = EAX
   y = EBX
   c = ECX,
   n = EDX
    }
asm
    mov EDX, 32
    MOV ECX, 16

@M_C_NOT_ZERO:
    CMP ECX,0
   JE @M_C_ZERO
    MOV EBX,EAX
    SHR EBX,CL
    CMP EBX,0
   JE @M_Y_ZERO
    SUB EDX,ECX
    MOV EAX,EBX
@M_Y_ZERO:
    SHR ECX,1
   JMP @M_C_NOT_ZERO
@M_C_ZERO:
    MOV EBX,EAX
    SHR EBX,31
    SUB EDX,EBX
    SUB EDX,EAX
    MOV EAX,EDX

end;

{====================================================}

{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{====================================================}
{====================================================}

procedure slog2(a,b,c:VnTip;var r:VnTip); assembler;
{  EAX -->    - a     }
{  EDX -->    - b     }
{  ECX -->    - c  -   }
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX

    mov ESI,eax  //   
    mov EBX,ecx
        CLD  // -  DI  SI  
{-------------------------------------------------}
    mov edi,r   //    r
    xor eax,eax
    mov ecx,dword ptr NewDl
  rep stosd            // r[1..NewDl]:=0

{-------------------------------------------------}
    lodsd            //  (razmer:=)eax:= a[0]
    cmp  EAX,[EDX]
   jae @Met1
    mov EAX,[EDX]   // if a[0]<b[0] then
@Met1:
    mov ECX,eax //razmer:= eax ,.. max  a[0]  b[0]
    mov edi,r    //  
    stosd     //     r 
    clc
{-------------------------------------------------}
@met_c:
    inc EDX        //    
    inc EDX
    inc EDX
    inc EDX
    LODSD
    ADC EAX,[EDX]  //         
    stosd
   loop @met_c
{-------------------------------------------------}

   JNC @net_rash   //    
    inc dword ptr r
    mov EAX,1
    stosd
@net_rash:
{-------------------------------------------------}
//       
{-------------------------------------------------}

{function A_MEN_B(a,b:VnTip):integer;  }

    mov eax,r      //  
    mov edx,[ebx]    //    = ebx
                     // edx =  
    cmp [eax],edx  // 
   ja @Met_kompensaciya_slog
   jb @Met_propusk_kompensacii_slog

    lea edi,[ebx+edx*4]  //  . 
    mov ecx,[eax]
    lea esi,[eax+ecx*4]  //  . 
   std     //  esi  edi - 
    mov ecx,[eax]
   repe cmpsd          //     
cld //  esi  edi 
   jb @Met_propusk_kompensacii_slog //   
{-------------------------------------------------}

@Met_kompensaciya_slog:

    //       
    //   (ebx)   (r)
   {------------------------------------------------}
    mov esi,r
    mov edi,r
    mov EDX,EBX
 {-------------------------------------------------}

    lodsd            //  (razmer:=)eax:= r[0]
    mov ECX,eax //razmer:= eax ,.. max  r[0]  c[0],  r>c
    stosd     //     r 
    clc       //   
{-------------------------------------------------}

@met_CIKL_KONPENSACII:
    inc EDX        //    
    inc EDX
    inc EDX
    inc EDX
    LODSD
    SBB EAX,[EDX]  //         
    stosd
   loop @met_CIKL_KONPENSACII
{-------------------------------------------------}
    MOV EAX,r
    MOV ECX,DWORD PTR [EAX]
@M_PROVERKA_RAZMERA_r:
    CMP DWORD PTR [EAX+ECX*4],0
   LOOPZ @M_PROVERKA_RAZMERA_r
    INC ECX                     // .. ECX      1
    MOV DWORD PTR [EAX],ECX      //   
@Met_propusk_kompensacii_slog:

 {-------------------------------------------------}
cld //   
        POP     EBX
        POP     ESI
        POP     EDI    {   /    }
end;

{====================================================}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{====================================================}

procedure razn2(a,b,c:VnTip;var r:VnTip); assembler;
var
   AdrA,AdrB,AdrC:LongWord;
{  : a    b }
{  EAX -->    - a     }
{  EDX -->    - b     }
{  ECX -->    - c  -   }
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX

    MOV AdrA,EAX
    MOV AdrB,EDX
    MOV AdrC,ECX //   
        CLD  // -  DI  SI  
{-------------------------------------------------}

    mov edi,r   //    r
    xor eax,eax
    mov ecx,dword ptr NewDl
    inc ecx
  rep stosd            // r[1..NewDl]:=0
{-------------------------------------------------}

{-------------------------------------------------}
//       
{-------------------------------------------------}

{function A_MEN_B(a,b:VnTip):integer; assembler;
asm }
 //       push edi
 //       push esi

    mov eax,AdrA      //  A
    MOV EBX,AdrB      // 
    mov edx,[ebx]    // edx =  
    cmp [eax],edx  // 

   ja @Met_propusk_kompensacii_Razn    // A>B
   jb @Met_kompensaciya_Razn             // A<B

    lea edi,[ebx+edx*4]  //  . B
    mov ecx,[eax]        //  
    lea esi,[eax+ecx*4]  //  . A
   std     //  esi  edi - 
//    cld     //  esi  edi - 
    mov ecx,[eax]
   repe cmpsd          //     
cld     //  esi  edi - 
   ja @Met_propusk_kompensacii_Razn    // A>B


@Met_kompensaciya_Razn:
   { , ..    }
   {-----------------------------------------------}
   {-----------------------------------------------}
    mov ESI,AdrA  //   
    mov EDX,AdrC
        CLD  // -  DI  SI  
{-------------------------------------------------}
    lodsd            //  (razmer:=)eax:= a[0]
    cmp  EAX,[EDX]
   jae @Met1_kompens
    mov EAX,[EDX]   // if a[0]<c[0] then
@Met1_kompens:
    mov ECX,eax //razmer:= eax ,.. max  a[0]  b[0]
    mov edi,r    //  
    stosd     //     r 
    clc       //   
{-------------------------------------------------}
@met_c_kompens:
    inc EDX        //    
    inc EDX
    inc EDX
    inc EDX
    LODSD
    ADC EAX,[EDX]  //         
    stosd
   loop @met_c_kompens
{-------------------------------------------------}
                   //   
   JNC @net_rash   //    
    inc dword ptr r
    mov EAX,1
    stosd
@net_rash:

  JMP @M_PROPUSK_COPY_A_v_Rez
   {-----------------------------------------------}
   {-----------------------------------------------}

@Met_propusk_kompensacii_Razn:    // A>B
   {}

   //    Rez

    MOV ESI,AdrA
    MOV EDI,r
    MOV ECX,DWORD PTR [ESI]   //    
    INC ECX                   //  
   REP MOVSD


@M_PROPUSK_COPY_A_v_Rez:
{-------------------------------------------------}
 //  R   A
    mov esi,r
    mov edx,AdrB

    lodsd            //  (razmer:=)eax:= a[0]
    cmp  EAX,[EDX]
    jae @Met1        // if a[0]<b[0] then 
    mov EAX,[EDX]
@Met1:
    mov ECX,eax //razmer:= eax ,.. max  a[0]  b[0]
    mov edi,r    //  
    stosd     //     r 
    clc
{-------------------------------------------------}

@met_c:
    inc EDX        //    
    inc EDX
    inc EDX
    inc EDX
    LODSD
    SBB EAX,[EDX]  //         
    stosd
    loop @met_c
{-------------------------------------------------}

cld //   
        POP     EBX
        POP     ESI
        POP     EDI    {   /    }
end;

{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}
{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}

procedure CopyMas(a,b:VnTip);
asm
    mov edi,eax   //    r
    xor eax,eax
    inc eax
    mov ecx,dword ptr NewDl
    inc ecx
   rep stosd            // r[1..NewDl]:=0

end;

end.



